
export function startEventListener(componentInstance) {

    document.addEventListener("visibilitychange", () => onVisibilitychange(componentInstance));

    return {
        dispose: () => stopEventListener()
    };
}

export function stopEventListener() {
    document.removeEventListener("visibilitychange", onVisibilitychange);
}

export function isVisible() {
    const result = document.visibilityState === 'visible'; // Possible values are: visible, hidden
    return result;
}

async function onVisibilitychange(componentInstance) {
    if (isVisible()) {
        await componentInstance.invokeMethodAsync("OnVisible");
    }
    else {
        await componentInstance.invokeMethodAsync("OnHide");
    }
}