// This is a JavaScript module that is loaded on demand. It can export any number of
// functions, and may import other JavaScript modules if required.

export function init() {

    const dataSpyList = document.querySelectorAll('[data-bs-spy="scroll"]')
    dataSpyList.forEach(dataSpyEl => {
        bootstrap.ScrollSpy.getOrCreateInstance(dataSpyEl).refresh();
    });
}

export function insertTextAtCursor(selector, text) {

    let inputFields = document.querySelectorAll(selector);
    inputFields.forEach(inputField => {

        if (inputField.selectionStart || inputField.selectionStart == '0') {

            let startPos = inputField.selectionStart;
            let endPos = inputField.selectionEnd;

            let startTxt = inputField.value.substring(0, startPos) + text;
            let endTxt = inputField.value.substring(endPos, inputField.value.length);

            inputField.value = startTxt + endTxt;

            let caretPos = startTxt.length;
            inputField.setSelectionRange(caretPos, caretPos);
        }
        else {
            inputField.value += text;
        }

        inputField.dispatchEvent(new Event('input', { "bubbles": true }));
    });

}