
export function getModalId(id) {
    const modalId = '#' + id;
    return modalId;
}

export function initialize(id, componentInstance) {

    const modal = document.getElementById(id)

    modal.addEventListener('hide.bs.modal', async event => {
        await componentInstance.invokeMethodAsync("OnHide");
    });

    modal.addEventListener('hidden.bs.modal', async event => {
        await componentInstance.invokeMethodAsync("OnHidden");
    });

    modal.addEventListener('show.bs.modal', async event => {
        await componentInstance.invokeMethodAsync("OnShow");
    });

    modal.addEventListener('shown.bs.modal', async event => {
        await componentInstance.invokeMethodAsync("OnShown");
    });

    return {
        dispose: () => dispose(id)
    };
}

export function show(id) {
    getOrCreateInstance(id)?.show();
}

export function hide(id) {
    getOrCreateInstance(id)?.hide();
}

export function toggle(id) {
    getOrCreateInstance(id)?.toggle();
}

export function getOrCreateInstance(id) {
    const modal = bootstrap.Modal.getOrCreateInstance(getModalId(id));
    return modal;
}

export function dispose(id) {
    const modal = bootstrap.Modal.getInstance(getModalId(id));
    if (modal) {

        // Bug fix: If the modal is not closed during navigation (Ex: if link in the modal)
        document.body.classList.remove('modal-open');
        document.body.style.paddingLeft = '';
        document.body.style.paddingRight = '';
        document.body.style.overflow = '';

        // Dispose
        modal.dispose();
    }
}