
export function startEventListener(componentInstance) {

    window.addEventListener("online", () => onNetworkStatusChange(componentInstance, true));
    window.addEventListener("offline", () => onNetworkStatusChange(componentInstance, false));

    return {
        dispose: () => stopEventListener()
    };
}

export function stopEventListener() {
    window.removeEventListener("online", onNetworkStatusChange);
    window.removeEventListener("offline", onNetworkStatusChange);
}

export function isOnline() {
    const result = navigator.onLine;
    return result;
}

async function onNetworkStatusChange(componentInstance, online) {
    await componentInstance.invokeMethodAsync("OnNetworkStatusChange", online);
}